/* GStreamer
 * Copyright (C) <2007> Chih-Wei Huang <cwhuang@linux.org.tw>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GST_ASTERISK_DEC_H__
#define __GST_ASTERISK_DEC_H__

#include <gst/gst.h>
//#include <gst/base/gstadapter.h>
#include <gst/rtp/gstbasertppayload.h>

G_BEGIN_DECLS

#define GST_TYPE_ASTERISK_DEC \
  (gst_asteriskdec_get_type())
#define GST_ASTERISK_DEC(obj) \
 (G_TYPE_CHECK_INSTANCE_CAST((obj),GST_TYPE_ASTERISK_DEC,GstAsteriskDec))
#define GST_ASTERISK_DEC_CLASS(klass) \
 (G_TYPE_CHECK_CLASS_CAST((klass),GST_TYPE_ASTERISK_DEC,GstAsteriskDecClass))
#define GST_IS_ASTERISK_DEC(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_ASTERISK_DEC))
#define GST_IS_ASTERISK_DEC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_ASTERISK_DEC))

#define GST_H263_RTP_PAD_TEMPLATE_CAPS \
  "application/x-rtp, " \
  "media = (string) \"video\", " \
  "payload = (int) " GST_RTP_PAYLOAD_H263_STRING ", " \
  "clock-rate = (int) 90000, " "encoding-name = (string) \"H263\""

#define GST_H263P_RTP_PAD_TEMPLATE_CAPS \
  "application/x-rtp, " \
  "media = (string) \"video\", " \
  "payload = (int) " GST_RTP_PAYLOAD_DYNAMIC_STRING ", " \
  "clock-rate = (int) 90000, " "encoding-name = (string) \"H263-1998\""

#define GST_H264_RTP_PAD_TEMPLATE_CAPS \
  "application/x-rtp, " \
  "media = (string) \"video\", " \
  "payload = (int) " GST_RTP_PAYLOAD_DYNAMIC_STRING ", " \
  "clock-rate = (int) 90000, " "encoding-name = (string) \"H264\""

typedef struct _GstAsteriskDec GstAsteriskDec;
typedef struct _GstAsteriskDecClass GstAsteriskDecClass;

struct _GstAsteriskDec
{
  GstBaseRTPPayload payload;

  guint32 codec;
  GstClockTime lastts;
  GstBuffer *remainder;
};

struct _GstAsteriskDecClass
{
  GstBaseRTPPayloadClass parent_class;
};

gboolean gst_asteriskdec_plugin_init (GstPlugin * plugin);

G_END_DECLS

#endif /* __GST_ASTERISK_DEC_H__ */
